=== debian/changelog ===
libemf2svg (1.1.0+ds-4) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Andrius Merkys ]
  * Configure with -DCMAKE_POLICY_VERSION_MINIMUM=3.5 (Closes: #1113145)
  * Bump copyright year.
  * Build-Depends: pkg-config => pkgconf

 -- Andrius Merkys <merkys@debian.org>  Fri, 03 Oct 2025 06:44:24 -0400

libemf2svg (1.1.0+ds-3) unstable; urgency=medium

  * Fix typo in package description (Closes: #992397).
  * Fix rpath issue with -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON.
  * Use buildflags.
  * Describe fix-install.patch.
  * Bump copyright years.

 -- Andrius Merkys <merkys@debian.org>  Mon, 04 Apr 2022 11:02:06 -0400

libemf2svg (1.1.0+ds-2) unstable; urgency=medium

  * zlib1g-dev is brought in by libpng-dev.
  * Fixing incorrect version in the manpage.
  * Transferring to Debian Multimedia Team.
  * Mentioning src/conv/emf2svg.cpp, which is licensed under MPL-2.0.

 -- Andrius Merkys <merkys@debian.org>  Mon, 16 Aug 2021 11:54:07 -0400

libemf2svg (1.1.0+ds-1) unstable; urgency=medium

  * Initial release (Closes: #987010)

 -- Andrius Merkys <merkys@debian.org>  Thu, 15 Apr 2021 04:34:42 -0400
