=== debian/control ===
Source: libemf2svg
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Section: libs
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 help2man,
 libfontconfig-dev,
 libfreetype-dev,
 libpng-dev,
 libuemf-dev,
 perl,
 pkgconf,
Standards-Version: 4.6.1
Homepage: https://github.com/kakwa/libemf2svg
Vcs-Browser: https://salsa.debian.org/multimedia-team/libemf2svg
Vcs-Git: https://salsa.debian.org/multimedia-team/libemf2svg.git
Rules-Requires-Root: no

Package: emf2svg
Section: graphics
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Convert Enhanced Metafile to SVG
 By themselves, EMF/EMF+ files are rare in the wild. However, they are
 frequently embedded inside other Microsoft file formats. This project could
 be used to handle EMF blobs in any Microsoft formats.
 .
 This package contains the command line utility emf2svg-conv.

Package: libemf2svg-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libemf2svg1 (= ${binary:Version}),
 ${misc:Depends},
Description: Enhanced Metafile to SVG conversion library (development files)
 By themselves, EMF/EMF+ files are rare in the wild. However, they are
 frequently embedded inside other Microsoft file formats. This project could
 be used to handle EMF blobs in any Microsoft formats.
 .
 This package contains the development files.

Package: libemf2svg1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Enhanced Metafile to SVG conversion library (shared library)
 By themselves, EMF/EMF+ files are rare in the wild. However, they are
 frequently embedded inside other Microsoft file formats. This project could
 be used to handle EMF blobs in any Microsoft formats.
 .
 This package contains the shared library.
