=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libemf2svg-$1.tar.gz%,repack,repacksuffix=+ds,dversionmangle=auto" \
 https://github.com/kakwa/libemf2svg/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
