=== debian/changelog ===
libemf2svg (1.8.0+ds-1) unstable; urgency=medium

  * New upstream version 1.8.0+ds
  * Drop unused patch use-system-libuemf.patch.
  * fix-install.patch has been suggested upstream.

 -- Andrius Merkys <merkys@debian.org>  Fri, 19 Dec 2025 03:13:14 -0500
