## libemf2svg 1.8.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 
 set(emf2svg_VERSION_MAJOR 1)
 set(emf2svg_VERSION_MINOR 8)
-set(emf2svg_VERSION_PATCH 0)
+set(emf2svg_VERSION_PATCH 1)
 set(emf2svg_VERSION ${emf2svg_VERSION_MAJOR}.${emf2svg_VERSION_MINOR}.${emf2svg_VERSION_PATCH})
 
 if(VCPKG_TARGET_TRIPLET)
@@ -205,16 +205,6 @@
 
 # Build external dependancies if we are on OSX
 if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
-  execute_process(
-    COMMAND brew --prefix
-      RESULT_VARIABLE BREW_PREFIX_RES
-      OUTPUT_VARIABLE BREW_PREFIX
-      OUTPUT_STRIP_TRAILING_WHITESPACE
-    )
-  if(NOT (BREW_PREFIX_RES EQUAL 0))
-      message(FATAL_ERROR "Could not find brew setup")
-  endif()
-  set(BREW_LIB_DIR ${BREW_PREFIX}/lib)
   set(EXTERNAL_ICONV "iconv")
   add_definitions(-DDARWIN)
 endif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
@@ -267,7 +257,6 @@
   link_directories(
     ${CMAKE_BINARY_DIR}
     ${EXTERNAL_LIB_DIR}
-    ${BREW_LIB_DIR}
   )
 endif(MSVC)
 
@@ -408,3 +397,4 @@
   ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
 )
 
+INSTALL(FILES inc/emf2svg.h DESTINATION ${INCLUDE_INSTALL_DIR})
