=== debian/changelog ===
libemf2svg (1.8.1+ds-1) unstable; urgency=medium

  * New upstream version 1.8.1+ds

 -- Andrius Merkys <merkys@debian.org>  Tue, 23 Dec 2025 04:09:54 -0500
