=== debian/control ===
--- 
+++ 
@@ -12,6 +12,7 @@
  libfreetype-dev,
  libpng-dev,
  libuemf-dev,
+ libxml2-dev,
  perl,
  pkgconf,
 Standards-Version: 4.6.1
