=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON -DCMAKE_POLICY_VERSION_MINIMUM=3.5
+	dh_auto_configure -- -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON -DCMAKE_POLICY_VERSION_MINIMUM=3.5 -DUSE_SYSTEM_LIBUEMF=ON
 
 override_dh_installman: debian/emf2svg-conv.1
 	dh_installman
